#!/system/bin/sh
########################################
# /data/local/bootimage-changer.sh
# permissions root:root -rwxr-xr-x 0755
########################################
# Boot image changer v1 2015-03-21
# Author: ooo @ android-hilfe.de
# Target devices: 
# Defy MB525/Defy Plus MB526
# Target ROM: 
# CM11 KitKat 4.4.4 New Life by Quarx @ xda
########################################

########################################
# open the partitions for writing
########################################
# save current states
local m_mount_bootstrap="ro"
local m_mount_root="ro"
local m_mount_system="ro"
local m_mount_data="ro"
if [ -w "/bootstrap" ]; then m_mount_bootstrap="rw"; fi
if [ -w "/" ]; then m_mount_root="rw"; fi
if [ -w "/system" ]; then m_mount_system="rw"; fi
if [ -w "/data" ]; then m_mount_data="rw"; fi
# set write state
mount -o remount,rw /bootstrap
mount -o remount,rw /
mount -o remount,rw /system
mount -o remount,rw /data

########################################
# ROM tweak: 
# (re-)place the recovery/start splash screen
# customized by the user randomly
# png image files must live in directory
# /data/local/bootimage-changer/
########################################
local m_target_dir="/data/local/bootimage-changer"
local m_goon="no"

if [ -d "$m_target_dir" ] ; then

   local m_target_file_name="background-def.png"

   # find all png files in the target directory
   local m_files=$( find "$m_target_dir/" -name "*.png" )

   # pick one of them randomly
   if [ ! -z "$m_files" ] ; then

      local m_count_files=$( echo "$m_files" | wc -l )
      local m_file_index=0

      if (( $m_count_files == 1 )); then m_file_index=1; fi

      while (( $m_file_index == 0 )); do

         m_file_index=$(( $RANDOM % $m_count_files ))
      done

      local m_file_name=$( echo "$m_files" | head -n "$m_file_index" | tail -n 1 )
      local m_goon="yes"
   fi
fi

# set the randomly picked png file as new boot image background
if [ "xyes" == "x$m_goon" ] ; then

   # system start
   if [ -e /system/bootstrap/images/background-def.png ] ; then

      cp "$m_file_name" /system/bootstrap/images/background-def.png
      chown root:root /system/bootstrap/images/background-def.png
      chmod 644 /system/bootstrap/images/background-def.png
   fi

   # bootstrap start
   if [ -e /bootstrap/bootstrap/images/background-def.png ] ; then

      cp "$m_file_name" /bootstrap/bootstrap/images/background-def.png
      chown root:root /bootstrap/bootstrap/images/background-def.png
      chmod 644 /bootstrap/bootstrap/images/background-def.png
   fi
fi

########################################
# reset the partitions to their initial state
########################################
mount -o remount,"$m_mount_data" /data
mount -o remount,"$m_mount_system" /system
mount -o remount,"$m_mount_root" /
mount -o remount,"$m_mopunt_bootstrap" /bootstrap

